#!/usr/bin/python

from Parser import TransferFrame
from multiprocessing import Process
from optparse import OptionParser

subsys = {}
subsys[0x0A0] = 'ngct1'
subsys[0x0B0] = 'ngct2'
subsys[0x0C0] = 'rgpsextnav'
subsys[0x0C1] = 'rgpssats'
subsys[0x0C2] = 'rgpschinfo'
subsys[0x0C3] = 'rgpsinfomon'
subsys[0x0C4] = 'nextppstimetag'
subsys[0x0E0] = 'rcc'
subsys[0x0F0] = 'pfssup'
subsys[0x0F1] = 'pfsinf'
subsys[0x100] = 'amubatt'
subsys[0x110] = 'tvcsup'
subsys[0x111] = 'tvcinf'
subsys[0x090] = 'FSU'
subsys[0x120] = 'tlmy'
subsys[0x7FF] = 'idle'

def main():
    parsecmdline = OptionParser()
    parsecmdline.add_option('-f', '--filename',
                            action='store', type='string', dest='filename',
                            help='Archivo de entrada')

    (options, args) = parsecmdline.parse_args()

    i = 0
    fd = open(options.filename, 'rb')

    files    = {}
    stats    = {}
    packets  = {}
    apidlost = {}
    apidlen  = {}
    framesn  = 0

    while fd.read(1) != '':
        fd.seek(fd.tell() - 1)

        frame = TransferFrame()
        frame.parseFrame(fd.read(2048))

        #print 'Procesando Frame: %d' % frame.getMasterChannelFrameCount()

        for packet in frame.getPackets():
            apid = packet.getAPID()

            if stats.has_key(apid) and packet.getPacketSequenceCount() - stats[apid] > 1:
                if apidlost.has_key(apid):
                    apidlost[apid] = apidlost[apid] + (packet.getPacketSequenceCount() - stats[apid]) - 1
                else:
                    apidlost[packet.getAPID()] =  packet.getPacketSequenceCount() - stats[apid] - 1


	    if apid != 0x7FF and apid != 0:
                stats[apid] = packet.getPacketSequenceCount()
                if not packets.has_key(apid):
                    packets[apid] = 0
                packets[apid] = packets[apid] + 1
		if not subsys.has_key(apid):
			print '0x%03X - no valido' % apid
                
                else:
                    if not files.has_key(apid):
                        files[apid] = open(options.filename+'-rawdata-'+subsys[apid]+'.dat', 'wb')
                    files[apid].write(packet.getRawPacket())


                apidlen[apid] = packet. getPacketDataLength()

        framesn = framesn + 1

    for key in files.keys():
        files[key].close()

    print
    print
    print '================================================================================'
    print '********************************* Reporte **************************************'
    print '================================================================================'
    print 'Frames Procesados: %d' % framesn
    print '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
    print

    print 'Contadores de Paquetes y Tamanno):'
    print '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
    for key in stats.keys():
        print 'APID: 0x%03X - Ultimo Contador:       %d\tlen: %d' % (key, stats[key], apidlen[key])
    print
    print 'Cantidad de paquetes CCSDS:'
    print '~~~~~~~~~~~~~~~~~~~~~~~~~~~'
    for key in packets.keys():
        print 'APID: 0x%03X - Cantidad de Paquetes:  %d' % (key, packets[key])
    print
    print 'Paquetes CCSDS Perdidos:'
    print '~~~~~~~~~~~~~~~~~~~~~~~~'
    if len(apidlost.keys()) == 0:
        print 'No hubo perdida de paquetes CCSDS'
    else:
        for key in apidlost.keys():
            print 'APID: 0x%03X - Paquetes Perdidos: %d' % (key, apidlost[key])
        
    
    
    

if __name__ == "__main__":
    main()


